<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">

	<title>BootStrap-Flex</title>
</head>
<body>
	<div class="container-fluid text-center">
		<h1>Bootstrap Flex</h1>
		<p>use the d-flex class to create a flex container and transform direct children in flex items.</p>

		<h2>Centering Elements</h2>
		<!-- d-flex the flex value will change the element into block level container IT WILL MAKE ALL THE CHILD ELEMETN BECOME FLECIBE THAT WILL ALLOW  THEM TO  OCCUPY SPACE enough for the contten of an element  at the same time  will have the elemts appear beside each other  -->
	<!--  justify-content-center it will horizontally center all child element  -->

	<!-- align-items-center class will vertically center all the child elemets -->

	<!-- flex-column- this class will display it atop of each other  -->

	<!-- flex-column-reverse it wil reverse the arrangerment of the divs  -->
		<div style="height:500px" class="bg-dark p-3 d-flex justify-content-center align-items-center flex-column ">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex item C</div>	
		</div>

		<h2>FLex Row</h2>
		<!-- flex-row changes how the elements display horizontaly -->
		<div class="bg-dark p-3 d-flex flex-row">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item C</div>
			<div class="h-25 p-3 bg-danger">Flex Item c</div>

		</div>

		<h2>Flex Row Reverse</h2>
		<div class="bg-dark p-3 d-flex flex-row-reverse">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item C</div>
			<div class="h-25 p-3 bg-danger">Flex Item c</div>
		</div>

		<h2>Creating Space Between Elements</h2>
		<!-- d-md-flex class will appy flex value to the display property  of a medium browser  -->

		<!-- justify-content-around may be only aplied if the element has a flex value it centers elements horizontaly while creating space betweeen elements snd the border of its parent container -->
		<div class="p-3 bg-dark d-md-flex justify-content-around ">
			<div class="p-3 bg-success col-md-2">Flex Item A</div>
			<div class="p-3 bg-warning col-md-2">Flex Item B</div>	
			<div class="p-3 bg-danger col-md-2">Flex Item C</div>
		</div>

		<h2>Flexboc wit margin</h2>
		<div class="bg-dark p-3 d-flex">
			<!-- mr-auto  Margin right automatic will ocupy the remaining width of its parent container push all the oterh elements inline  -->
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning mr-auto">Flex Item B</div>	
			<div class="p-3 bg-danger ">Flex Item C</div>
			<div class="p-3 bg-primary">Flex Item D</div>
		</div>


		<h2>Nested Flex Element</h2>
		<div class=" bg-dark p-2 d-md-flex">
			<div class="p-3 bg-success mr-auto"> Flex Item A</div>
			<div class="d-flex justify-content-between w-50 ">
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
				<div class="p-3 bg-primary">Flex Item D</div>
			</div>
		</div>

	</div>


		<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
		<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>
</html>